### R code from vignette source 'BoolNet_package_vignette.Snw'

###################################################
### code chunk number 1: BoolNet_package_vignette.Snw:65-66 (eval = FALSE)
###################################################
## install.packages("BoolNet")


###################################################
### code chunk number 2: BoolNet_package_vignette.Snw:70-71
###################################################
library(BoolNet)


###################################################
### code chunk number 3: BoolNet_package_vignette.Snw:148-149
###################################################
cellcycle <- loadNetwork("cellcycle.txt")


###################################################
### code chunk number 4: BoolNet_package_vignette.Snw:153-154
###################################################
data(cellcycle)


###################################################
### code chunk number 5: BoolNet_package_vignette.Snw:167-168
###################################################
data(yeastTimeSeries)


###################################################
### code chunk number 6: BoolNet_package_vignette.Snw:173-174
###################################################
binSeries <- binarizeTimeSeries(yeastTimeSeries)


###################################################
### code chunk number 7: BoolNet_package_vignette.Snw:179-181
###################################################
net <- reconstructNetwork(binSeries$binarizedMeasurements, 
method="bestfit", maxK=4)


###################################################
### code chunk number 8: BoolNet_package_vignette.Snw:187-188
###################################################
net


###################################################
### code chunk number 9: BoolNet_package_vignette.Snw:193-194
###################################################
plotNetworkWiring(net)


###################################################
### code chunk number 10: BoolNet_package_vignette.Snw:211-212
###################################################
singleNet <- chooseNetwork(net, c(1,2,3,2))


###################################################
### code chunk number 11: BoolNet_package_vignette.Snw:216-217
###################################################
singleNet


###################################################
### code chunk number 12: BoolNet_package_vignette.Snw:223-224
###################################################
net <- generateRandomNKNetwork(n=10, k=3)


###################################################
### code chunk number 13: BoolNet_package_vignette.Snw:227-228
###################################################
net <- generateRandomNKNetwork(n=10, k=c(1,2,3,1,3,2,3,2,1,1))


###################################################
### code chunk number 14: BoolNet_package_vignette.Snw:233-234
###################################################
net <- generateRandomNKNetwork(n=20, k=20, topology="scale_free")


###################################################
### code chunk number 15: BoolNet_package_vignette.Snw:238-239
###################################################
net <- generateRandomNKNetwork(n=10, k=3, linkage="lattice")


###################################################
### code chunk number 16: BoolNet_package_vignette.Snw:244-246
###################################################
net <- generateRandomNKNetwork(n=10, k=3, 
functionGeneration="biased", zeroBias=0.75)


###################################################
### code chunk number 17: BoolNet_package_vignette.Snw:257-259
###################################################
data(cellcycle)
knockedOut <- fixGenes(cellcycle, "cycd", 0)


###################################################
### code chunk number 18: BoolNet_package_vignette.Snw:262-263
###################################################
knockedOut <- fixGenes(cellcycle, 1, 0)


###################################################
### code chunk number 19: BoolNet_package_vignette.Snw:266-267
###################################################
overExpressed <- fixGenes(cellcycle, "cycd", 1)


###################################################
### code chunk number 20: BoolNet_package_vignette.Snw:270-271
###################################################
originalNet <- fixGenes(knockedOut, "cycd", -1)


###################################################
### code chunk number 21: BoolNet_package_vignette.Snw:276-277
###################################################
newNet <- fixGenes(cellcycle, c("cycd","cyce"), c(0,1))


###################################################
### code chunk number 22: BoolNet_package_vignette.Snw:289-291
###################################################
data(cellcycle)
stateTransition(cellcycle, rep(1,10))


###################################################
### code chunk number 23: BoolNet_package_vignette.Snw:294-295
###################################################
getPathToAttractor(cellcycle,rep(0,10))


###################################################
### code chunk number 24: BoolNet_package_vignette.Snw:300-301 (eval = FALSE)
###################################################
## stateTransition(cellcycle, rep(1,10), type="asynchronous")


###################################################
### code chunk number 25: BoolNet_package_vignette.Snw:309-311 (eval = FALSE)
###################################################
## stateTransition(cellcycle, rep(1,10), type="asynchronous", 
## geneProbabilities=c(0.05,0.05,0.2,0.3,0.05,0.05,0.05,0.05,0.1,0.1))


###################################################
### code chunk number 26: BoolNet_package_vignette.Snw:320-322
###################################################
stateTransition(cellcycle, rep(1,10), type="asynchronous", 
chosenGene="cyce")


###################################################
### code chunk number 27: BoolNet_package_vignette.Snw:327-328
###################################################
data(examplePBN)


###################################################
### code chunk number 28: BoolNet_package_vignette.Snw:330-332 (eval = FALSE)
###################################################
## data(examplePBN)
## stateTransition(examplePBN, c(0,1,1), type="probabilistic")


###################################################
### code chunk number 29: BoolNet_package_vignette.Snw:338-340
###################################################
stateTransition(examplePBN, c(0,1,1), type="probabilistic", 
chosenFunctions=c(2,1,2))


###################################################
### code chunk number 30: BoolNet_package_vignette.Snw:358-359
###################################################
attr <- getAttractors(cellcycle)


###################################################
### code chunk number 31: BoolNet_package_vignette.Snw:361-364 (eval = FALSE)
###################################################
## data(cellcycle)
## attr <- getAttractors(cellcycle)
## attr


###################################################
### code chunk number 32: BoolNet_package_vignette.Snw:408-409 (eval = FALSE)
###################################################
## print(attr, activeOnly=TRUE)


###################################################
### code chunk number 33: BoolNet_package_vignette.Snw:432-434 (eval = FALSE)
###################################################
## tt <- getTransitionTable(attr)
## tt


###################################################
### code chunk number 34: BoolNet_package_vignette.Snw:448-449 (eval = FALSE)
###################################################
## getBasinOfAttraction(attr, 1)


###################################################
### code chunk number 35: BoolNet_package_vignette.Snw:454-455 (eval = FALSE)
###################################################
## getStateSummary(attr, c(1,1,1,1,1,1,1,1,1,1))


###################################################
### code chunk number 36: BoolNet_package_vignette.Snw:467-468
###################################################
plotStateGraph(attr)


###################################################
### code chunk number 37: BoolNet_package_vignette.Snw:481-482
###################################################
plotStateGraph(attr, piecewise=TRUE)


###################################################
### code chunk number 38: BoolNet_package_vignette.Snw:496-498 (eval = FALSE)
###################################################
## attr <- getAttractors(cellcycle, method="chosen", 
## startStates=list(rep(0,10),rep(1,10)))


###################################################
### code chunk number 39: BoolNet_package_vignette.Snw:502-503 (eval = FALSE)
###################################################
## attr <- getAttractors(cellcycle, method="random", startStates=100)


###################################################
### code chunk number 40: BoolNet_package_vignette.Snw:512-513 (eval = FALSE)
###################################################
## plotAttractors(attr,subset=2)


###################################################
### code chunk number 41: BoolNet_package_vignette.Snw:516-517 (eval = FALSE)
###################################################
## attractorsToLaTeX(attr,subset=2,file="attractors.tex")


###################################################
### code chunk number 42: BoolNet_package_vignette.Snw:531-533 (eval = FALSE)
###################################################
## attr <- getAttractors(cellcycle, type="asynchronous",
## method="random", startStates=500)


###################################################
### code chunk number 43: BoolNet_package_vignette.Snw:538-539 (eval = FALSE)
###################################################
## attr


###################################################
### code chunk number 44: BoolNet_package_vignette.Snw:567-569 (eval = FALSE)
###################################################
## attr <- getAttractors(cellcycle, type="asynchronous",
## method="random", startStates=500, avoidSelfLoops=FALSE)


###################################################
### code chunk number 45: BoolNet_package_vignette.Snw:576-577 (eval = FALSE)
###################################################
## plotAttractors(attr,subset=2,mode="graph",drawLabels=FALSE)


###################################################
### code chunk number 46: BoolNet_package_vignette.Snw:595-598
###################################################
data(examplePBN)
sim <- markovSimulation(examplePBN)
sim


###################################################
### code chunk number 47: BoolNet_package_vignette.Snw:604-605
###################################################
plotPBNTransitions(sim)


###################################################
### code chunk number 48: BoolNet_package_vignette.Snw:618-622
###################################################
data(cellcycle)
sim <- markovSimulation(cellcycle, numIterations=1024, 
returnTable=FALSE)
sim


###################################################
### code chunk number 49: BoolNet_package_vignette.Snw:631-634
###################################################
sim <- markovSimulation(cellcycle, numIterations=1024,
returnTable=FALSE, startStates=list(rep(1,10)))
sim


###################################################
### code chunk number 50: BoolNet_package_vignette.Snw:643-646
###################################################
data(cellcycle)
perturbedNet <- perturbNetwork(cellcycle, perturb="functions", 
method="bitflip")


###################################################
### code chunk number 51: BoolNet_package_vignette.Snw:651-653
###################################################
perturbedNet <- perturbNetwork(cellcycle, perturb="functions", 
method="shuffle")


###################################################
### code chunk number 52: BoolNet_package_vignette.Snw:659-661
###################################################
perturbedNet <- perturbNetwork(cellcycle, perturb="states", 
method="bitflip", numStates=10)


###################################################
### code chunk number 53: BoolNet_package_vignette.Snw:693-749 (eval = FALSE)
###################################################
## # Perform a robustness test on a network
## # by counting the numbers of perturbed networks
## # containing the attractors of the original net
## 
## library(BoolNet)
## 
## # load mammalian cell cycle network
## data(cellcycle)
## 
## # get attractors in original network
## attrs <- getAttractors(cellcycle, canonical=TRUE)
## 
## # create 1000 perturbed copies of the network and search for attractors
## perturbationResults <- sapply(1:1000,function(i)
## {
##   # perturb network and identify attractors
##   perturbedNet <- perturbNetwork(cellcycle, perturb="functions", method="bitflip")
##   perturbedAttrs <- getAttractors(perturbedNet, canonical=TRUE)
##   
##   # check whether the attractors in the original network exist in the perturbed network
##   attractorIndices <- sapply(attrs$attractors,function(attractor1)
##         {
##           index <- which(sapply(perturbedAttrs$attractors,function(attractor2)
##             {
##               identical(attractor1,attractor2)
##             }))
##           if (length(index) == 0)
##             NA
##           else
##             index
##         })
##   return(attractorIndices)
## })
## 
## # perturbationResults now contains a matrix
## # with the first 2 columns specifying the indices or the 
## # original attractors in the perturbed network 
## # (or NA if the attractor was not found) and the next 2 
## # columns counting the numbers of states
## # in the basin of attraction (or NA if the attractor was not found)
## 
## # measure the total numbers of occurrences of the original attractors in the perturbed copies
## numOccurrences <- apply(perturbationResults[1:length(attrs$attractors),,drop=FALSE], 1,
##                       function(row)sum(!is.na(row)))
## 
## # print original attractors
## cat("Attractors in original network:\n")
## print(attrs)
## 
## # print information
## cat("Number of occurrences of the original attractors",
## 	"in 1000 perturbed copies of the network:\n")
## for (i in 1:length(attrs$attractors))
## {
##   cat("Attractor ",i,": ",numOccurrences[i],"\n",sep="")
## }


###################################################
### code chunk number 54: BoolNet_package_vignette.Snw:759-763 (eval = FALSE)
###################################################
## data(cellcycle)
## testNetworkProperties(cellcycle, numRandomNets=100, 
## testFunction="testAttractorRobustness", 
## testFunctionParams = list(copies=100))


###################################################
### code chunk number 55: BoolNet_package_vignette.Snw:777-779 (eval = FALSE)
###################################################
## testNetworkProperties(cellcycle, numRandomNets=100, 
## testFunction="testIndegree")


###################################################
### code chunk number 56: BoolNet_package_vignette.Snw:793-795 (eval = FALSE)
###################################################
## testNetworkProperties(cellcycle, numRandomNets=100, 
## testFunction="testIndegree", accumulation="kullback_leibler")


###################################################
### code chunk number 57: BoolNet_package_vignette.Snw:816-828
###################################################
testBasinSizes <- function(network, accumulate=TRUE, params)
{
  attr <- getAttractors(network)
  basinSizes <- sapply(attr$attractors, function(a)
                      { 
                         a$basinSize
                      })
   if (accumulate)
     return(mean(basinSizes))
   else
     return(basinSizes)                  
}


###################################################
### code chunk number 58: BoolNet_package_vignette.Snw:834-837 (eval = FALSE)
###################################################
## testNetworkProperties(cellcycle, numRandomNets=1000,
## testFunction="testBasinSizes",
## xlab="Average size of basins of attraction")


###################################################
### code chunk number 59: BoolNet_package_vignette.Snw:868-869 (eval = FALSE)
###################################################
## system.file("doc/example.btp", package="BoolNet")


###################################################
### code chunk number 60: BoolNet_package_vignette.Snw:901-902
###################################################
net <- loadBioTapestry("example.btp")


###################################################
### code chunk number 61: BoolNet_package_vignette.Snw:908-909 (eval = FALSE)
###################################################
## net


###################################################
### code chunk number 62: BoolNet_package_vignette.Snw:931-932 (eval = FALSE)
###################################################
## plotNetworkWiring(net)


###################################################
### code chunk number 63: BoolNet_package_vignette.Snw:953-956 (eval = FALSE)
###################################################
## data(cellcycle)
## attr <- getAttractors(cellcycle)
## toPajek(attr, file="cellcycle.net")


###################################################
### code chunk number 64: BoolNet_package_vignette.Snw:960-961 (eval = FALSE)
###################################################
## toPajek(attr, file="cellcycle.net", includeLabels=TRUE)


